/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
    QC_AbstractPollOperation.qpp

    AbstractPollOperation class definition

    Qore Programming Language

    Copyright (C) 2003 - 2023 Qore Technologies, s.r.o.

    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.

    Note that the Qore library is released under a choice of three open-source
    licenses: MIT (as above), LGPL 2+, or GPL 2+; see README-LICENSE for more
    information.
*/

#include "qore/Qore.h"

class AbstractPollOperation {
};
/* Qore class Qore::AbstractPollOperation */

qore_classid_t CID_ABSTRACTPOLLOPERATION;
QoreClass* QC_ABSTRACTPOLLOPERATION;

// auto AbstractPollOperation::getOutput(){}
static QoreValue AbstractPollOperation_getOutput(QoreObject* self, AbstractPollOperation* poll, const QoreListNode* args, q_rt_flags_t rtflags, ExceptionSink* xsink) {
# 71 "QC_AbstractPollOperation.qpp"
    return QoreValue();
}

DLLLOCAL void preinitAbstractPollOperationClass() {
    QC_ABSTRACTPOLLOPERATION = new QoreClass("AbstractPollOperation", "::Qore::AbstractPollOperation", QDOM_DEFAULT);
    CID_ABSTRACTPOLLOPERATION = QC_ABSTRACTPOLLOPERATION->getID();
    QC_ABSTRACTPOLLOPERATION->setSystem();
}

DLLLOCAL QoreClass* initAbstractPollOperationClass(QoreNamespace& ns) {
    if (!QC_ABSTRACTPOLLOPERATION)
        preinitAbstractPollOperationClass();

    // *hash<SocketPollInfo> AbstractPollOperation::continuePoll();
    QC_ABSTRACTPOLLOPERATION->addAbstractMethod("continuePoll", Public, QCF_NO_FLAGS, hashdeclSocketPollInfo->getTypeInfo(true));

    // string AbstractPollOperation::getGoal();
    QC_ABSTRACTPOLLOPERATION->addAbstractMethod("getGoal", Public, QCF_NO_FLAGS, stringTypeInfo);

    // auto AbstractPollOperation::getOutput(){}
    QC_ABSTRACTPOLLOPERATION->addMethod("getOutput", (q_method_n_t)AbstractPollOperation_getOutput, Public, QCF_RET_VALUE_ONLY, QDOM_DEFAULT, autoTypeInfo);

    // string AbstractPollOperation::getState();
    QC_ABSTRACTPOLLOPERATION->addAbstractMethod("getState", Public, QCF_NO_FLAGS, stringTypeInfo);

    // bool AbstractPollOperation::goalReached();
    QC_ABSTRACTPOLLOPERATION->addAbstractMethod("goalReached", Public, QCF_NO_FLAGS, boolTypeInfo);

    return QC_ABSTRACTPOLLOPERATION;
}
