/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_AbstractQuantifiedIterator.qpp AbstractQuantifiedIterator class (interface) definition */
/*
  Qore Programming Language

  Copyright (C) 2003 - 2023 David Nichols

  Permission is hereby granted, free of charge, to any person obtaining a
  copy of this software and associated documentation files (the "Software"),
  to deal in the Software without restriction, including without limitation
  the rights to use, copy, modify, merge, publish, distribute, sublicense,
  and/or sell copies of the Software, and to permit persons to whom the
  Software is furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
  DEALINGS IN THE SOFTWARE.

  Note that the Qore library is released under a choice of three open-source
  licenses: MIT (as above), LGPL 2+, or GPL 2+; see README-LICENSE for more
  information.
*/

#include <qore/Qore.h>
/* Qore class Qore::AbstractQuantifiedIterator */

qore_classid_t CID_ABSTRACTQUANTIFIEDITERATOR;
QoreClass* QC_ABSTRACTQUANTIFIEDITERATOR;

DLLLOCAL void preinitAbstractQuantifiedIteratorClass() {
    QC_ABSTRACTQUANTIFIEDITERATOR = new QoreClass("AbstractQuantifiedIterator", "::Qore::AbstractQuantifiedIterator", QDOM_DEFAULT);
    CID_ABSTRACTQUANTIFIEDITERATOR = QC_ABSTRACTQUANTIFIEDITERATOR->getID();
    QC_ABSTRACTQUANTIFIEDITERATOR->setSystem();
}

DLLLOCAL QoreClass* initAbstractQuantifiedIteratorClass(QoreNamespace& ns) {
    if (!QC_ABSTRACTQUANTIFIEDITERATOR)
        preinitAbstractQuantifiedIteratorClass();

    // set parent class
    assert(QC_ABSTRACTITERATOR);
    QC_ABSTRACTQUANTIFIEDITERATOR->addBuiltinVirtualBaseClass(QC_ABSTRACTITERATOR);

    // bool AbstractQuantifiedIterator::empty();
    QC_ABSTRACTQUANTIFIEDITERATOR->addAbstractMethod("empty", Public, QCF_NO_FLAGS, boolTypeInfo);

    // bool AbstractQuantifiedIterator::first();
    QC_ABSTRACTQUANTIFIEDITERATOR->addAbstractMethod("first", Public, QCF_NO_FLAGS, boolTypeInfo);

    // bool AbstractQuantifiedIterator::last();
    QC_ABSTRACTQUANTIFIEDITERATOR->addAbstractMethod("last", Public, QCF_NO_FLAGS, boolTypeInfo);

    return QC_ABSTRACTQUANTIFIEDITERATOR;
}
